Strict
Graphics 640,480,0,85
SeedRnd MilliSecs()
Global list:TList=CreateList()
Global win
Global score=0
t_p.f_create()
t_e.f_create()

Repeat
f_up()
Flip
Cls
Until KeyHit(key_escape)

Type t_p
	Field x#,y#,cooldown,hp
	
	Function f_create()
	Local p:t_p=New t_p
	p.x=240
	p.y=440
	p.cooldown=0
	p.hp=1
	ListAddLast list,p
	End Function
	
	Method m_up()
	If KeyDown(key_left) And x>20 x:-2
	If KeyDown(key_right) And x<460 x:+2
	If KeyDown(key_up) And y>20 y:-2
	If KeyDown(key_down) And y<460 y:+2
		
	If cooldown>0 cooldown:-1
		
	If KeyDown(key_space) And cooldown=0 And hp=1
	cooldown=5
	t_shot.f_create(x-10,y-10,270,6,0)
	t_shot.f_create(x+10,y-10,270,6,0)
	EndIf
		
	For Local s:t_shot=EachIn list
	If s.source=1
	If f_collision(x,y,10,s.x,s.y,5) And win=0 hp=0
	EndIf
	Next
		
	SetColor 100,100,100
	If hp=1 DrawOval x-20,y-20,40,40 Else DrawText "GAME OVER",240,240
	SetColor 255,255,255
	End Method
End Type

Type t_e
	Field x#[226],y#[226],d#[226],hp[10],t,shoot
	
	Function f_create()
	Local e:t_e=New t_e
	For Local i=0 To 224
	e.x[i]=640+i*2
	e.y[i]=100
	e.d[i]=180
	e.shoot=240
	Next
	For Local i=0 To 9
	e.hp[i]=100
	Next
	ListAddLast list,e
	End Function
	
	Method m_up()
		t:+1
		If t>=200 And t<290 d[0]:-2
		If t>=330 And t<375 d[0]:+4
		If t>=440 And t<530 d[0]:+2
		If t>=500 And t<590 d[0]:-2
		If t>=600 And t<870 d[0]:-1
		If t>=900 And t<1080 d[0]:+1
		If t>=1200 And t<1290 d[0]:+1
		If t>=1380 And t<1470 d[0]:+1
		If t>=1570 And t<1660 d[0]:+1
		If t=2100
			t=0
			For Local i=0 To 224
				x[i]=640+i*2
				y[i]=100
				d[i]=180
			Next
		EndIf
				
		x[0]:+ 2*Cos(d[0])
		y[0]:+ 2*Sin(d[0])
		
		For Local i=0 To 224
			x[225-i]= x[224-i]
			y[225-i]= y[224-i]
			d[225-i]= d[224-i]
		Next
		
		If shoot>0 shoot:-1
		
		If shoot=0
			Local attack=Int(Rnd(2))
			shoot=Int(Rnd(40))+30
			Local pos=Int(Rnd(9)*25)
			If attack=0
				For Local i=0 To 18
					t_shot.f_create(x[pos],y[pos],i*20,2,1)
				Next
			EndIf
			If attack=1
				Local dir#
				For Local target:t_p=EachIn list
					dir= ATan2(target.y-y[pos],target.x-x[pos])
				Next
				For Local i=0 To 18
					t_shot.f_create(x[pos]+20*Cos(i*20),y[pos]+20*Sin(i*20),dir,2,1)
				Next
			EndIf
		EndIf
		
		For Local i=0 To 9
			For Local s:t_shot=EachIn list
				If s.source=0
					For Local i=0 To 9
						If f_collision(x[i*25],y[i*25],20,s.x,s.y,5)
							If hp[i]>0
								hp[i]:-1
								score:+1000
							EndIf
							list.remove(s)
						EndIf
					Next
				EndIf
			Next
			For Local p:t_p=EachIn list
				For Local i=0 To 9
					If f_collision(x[i*25],y[i*25],20,p.x,p.y,10)
						p.hp=0
					EndIf
				Next
			Next
			
			Local damage=0
			For Local i=0 To 9
				If hp[i]=0 damage:+1
			Next
			If damage=7
				list.remove(Self)
				win=1
			EndIf
			
			If hp[i]=0 SetColor 255,255,255 Else SetColor 55+(100-hp[i]),55+(100-hp[i]),55+(100-hp[i])
				If i=0 DrawOval x[i]-25,y[i]-25,50,50 Else DrawOval x[i*25-1]-25,y[i*25-1]-25,50,50
			SetColor 255,255,255
		Next
	End Method
End Type

Type t_shot
	Field x#,y#,d#,speed#,source
	
	Function f_create(x#,y#,d#,speed#,source)
	Local s:t_shot=New t_shot
	s.x=x
	s.y=y
	s.d=d
	s.speed=speed
	s.source=source
	ListAddLast list,s
	End Function
	
	Method m_up()
	x:+ speed*Cos(d)
	y:+ speed*Sin(d)
		
	If y<-10 Or y>490 Or x<-10 Or x>490 list.remove(Self)
	If source=0 SetColor 100,100,100 Else SetColor 200,200,200
	DrawRect x-5,y-5,10,10
	SetColor 255,255,255
	End Method
End Type

Function f_up()
For Local p:t_p=EachIn list
p.m_up()
Next
For Local e:t_e=EachIn list
e.m_up()
Next
For Local s:t_shot=EachIn list
s.m_up()
Next
SetColor 100,100,100
DrawRect 480,0,160,480
SetColor 255,255,255
DrawText score,490,10
If win=1 DrawText "MISSION COMPLETE",220,240
End Function

Function f_collision(x1#,y1#,b1#,x2#,y2#,b2#)
If y1+b1 < y2-b2 Return
If y1-b1 > y2+b2 Return
If x1+b1 < x2-b2 Return
If x1-b1 > x2+b2 Return
Return 1
End Function