Graphics 800,600,16,1

SetBuffer BackBuffer()
SeedRnd MilliSecs()
FlushKeys
FlushMouse


FONT1=LoadFont("Arial",30,True,False,False)
FONT2=LoadFont("Arial",40,False,False,False)
FONT3=LoadFont("Arial",60,False,False,False)
FONT4=LoadFont("Arial",150,False,False,False)


STARSNIP=LoadImage("D/Starsnip.bmp") : MaskImage STARSNIP,255,0,255
ASTEROID=LoadImage("D/Asteroid.bmp") : MaskImage ASTEROID,255,0,255


GAMESOUND = LoadSound("D/Ingame.mp3") : LoopSound GAMESOUND
COUNTSOUND = LoadSound("D/Count.wav")
EXPLOSOUND = LoadSound("D/Explode.wav")


Type GEGNER
	Field X#,Y#,SPEED#,TIMER
End Type

Type EXPLO
	Field X#,Y#,YSPEED#,SPEED#
End Type


DATEI = ReadFile("D/Highscore.dat")
HIGHSCORE1 = ReadInt(DATEI)
HIGHSCORE2 = ReadInt(DATEI)
HIGHSCORE3 = ReadInt(DATEI)
CloseFile(DATEI)


.start

SCORE = 0
GEGNERPROSEKUNDE=12
FRAMEPAUSE = MilliSecs()
GO=4
GOTIMER=0

MoveMouse(250,280)

While Not KeyDown(1)

	Cls

	TICKS = MilliSecs()
	SPEEDUP = (TICKS - FRAMEPAUSE) / (1000 / 60.0)
	If SPEEDUP <= 0 Then SPEEDUP = 0.00000000001
	FRAMEPAUSE = TICKS


	If GO=0
		If MilliSecs() > GEGNERTIMER + (1000/GEGNERPROSEKUNDE)
			G.GEGNER = New GEGNER
			G\X#=800
			G\Y#=Rand(0,GraphicsHeight()-20)
			GEGNERPROSEKUNDE=5+(SCORE/200)
			If GEGNERPROSEKUNDE>12 Then GEGNERPROSEKUNDE=12
			GSPEED#=Rnd#(5+(SCORE/200),10+(SCORE/200))
			If GSPEED#>12 Then GSPEED#=12
			G\SPEED#=GSPEED		
			G\TIMER=0
			GEGNERTIMER=MilliSecs()
		EndIf
	EndIf


	For G.GEGNER = Each GEGNER
		DrawImage ASTEROID,G\X#,G\Y#
		If GO=0
			If ImagesCollide (STARSNIP,MouseX(),MouseY(),0,ASTEROID,G\X#,G\Y#,0)
				StopChannel CHN
				PlaySound  EXPLOSOUND
				For I=1 To 500
					E.EXPLO = New EXPLO
					E\X#=G\X# :	E\Y#=G\Y#
					E\SPEED#=Rnd#(-5.0,5.0)*5.0
					E\YSPEED#=Rnd#(-5.0,5.0)*5.0
				Next
				FlushKeys
				GO=9
				HIGHSCORE=False
				If SCORE>HIGHSCORE1 Then
					HIGHSCORE3=HIGHSCORE2
					HIGHSCORE2=HIGHSCORE1
					HIGHSCORE1=SCORE
					HIGHSCORE=True
				EndIf
				If SCORE>HIGHSCORE2 And HIGHSCORE=False Then
					HIGHSCORE3=HIGHSCORE2
					HIGHSCORE2=SCORE
					HIGHSCORE=True
				EndIf
				If SCORE>HIGHSCORE3 And HIGHSCORE=False Then
					HIGHSCORE3=SCORE
					HIGHSCORE=True
				EndIf
				If HIGHSCORE=True Then
					DATEI = WriteFile("D/Highscore.dat")
					WriteInt(DATEI, HIGHSCORE1)
					WriteInt(DATEI, HIGHSCORE2)
					WriteInt(DATEI, HIGHSCORE3)
					CloseFile(DATEI)
				EndIf
			EndIf
		EndIf
		G\X# = G\X# - (G\SPEED# * SPEEDUP)
		If G\X# < -150 Then	Delete G
	Next


    If MouseX()>720 Then MoveMouse(720,MouseY())
    If MouseY()>550 Then MoveMouse(MouseX(),550)
	DrawImage STARSNIP,MouseX(),MouseY()

	Color 255,255,0
	For E.EXPLO = Each EXPLO
		Oval E\X#,E\Y#,3,3,1
		E\X# = E\X# - (E\SPEED# * SPEEDUP)
		E\Y# = E\Y# + (E\YSPEED# * SPEEDUP)
		If (E\X# < 0 Or E\X# > GraphicsWidth()) Or (E\Y# < 0 Or E\Y# > GraphicsHeight()) Then Delete E
	Next
	Color 255,255,255


	If GO=0 Then
		SetFont FONT1
		Text 20,10,"Score: " + SCORE
	End If
	
	If GO=9
		CHN=PlaySound (SCORESOUND)
		SetFont FONT3
		If HIGHSCORE=True Then
			Text 400,100,"HIGHSCORE: " + SCORE,1,1
		Else
			Text 400,100,"SCORE: " + SCORE,1,1		
		End If
		SetFont FONT2
		Text 400,200,"--== HIGHSCORES ==--",1,1
		Text 400,250,HIGHSCORE1,1,1
		Text 400,290,HIGHSCORE2,1,1
		Text 400,330,HIGHSCORE3,1,1
		SetFont FONT1
		Text 400,450,"-- SPACE fr Neustart --",1,1
		Text 400,480,"-- ESC fr Beenden --",1,1
		If KeyHit(57) Then Goto Start
	EndIf


	If GO<9 And GO>0
		SetFont FONT4
		Text 400,300,GO,1,1
		If MilliSecs() > GOTIMER + 1000
			GO=GO-1
			PlaySound COUNTSOUND
			GOTIMER=MilliSecs()
		EndIf
		If GO=0 Then CHN=PlaySound (GAMESOUND)
	EndIf


	If MilliSecs() > SCORETIMER + 200
		SCORETIMER=MilliSecs()
		If GO=0 Then SCORE=SCORE+10
	EndIf


	Flip

Wend

End